#
#
#
use BASILIX\p\g

CREATE TABLE ADDRESSBOOK (
    ROWID	BIGINT(21)	NOT NULL DEFAULT '1' AUTO_INCREMENT,
    OWNERID	BIGINT(21)	NOT NULL,
    NICKNAME	VARCHAR(20)	NOT NULL,
    EMAIL	VARCHAR(64)	NOT NULL,
    NAME	VARCHAR(64),
    TELEPHONE	VARCHAR(64),
    FAX		VARCHAR(64),
    NOTE	VARCHAR(128), 
    PRIMARY KEY(ROWID)
)\p\g

CREATE TABLE ADDRESSBOOKGRP (
    ROWID	BIGINT(21)	NOT NULL DEFAULT '1' AUTO_INCREMENT,
    OWNERID	BIGINT(21)	NOT NULL,
    GRPNAME	VARCHAR(32)	NOT NULL,
    MEMBERS	VARCHAR(128)	NOT NULL DEFAULT '',
    PRIMARY KEY(ROWID)
)\p\g

CREATE TABLE SESSION (
   CUSTOMERID	BIGINT(21)	NOT NULL DEFAULT '1' AUTO_INCREMENT,
   USERNAME	VARCHAR(20)	NOT NULL,
   DOMAIN	VARCHAR(64)	NOT NULL,
   PASSWORD	VARCHAR(16),
   SESSIONID	VARCHAR(36),
   LASTACCESS	VARCHAR(12)	NOT NULL,
   LASTTIME	VARCHAR(12)	NOT NULL,
   LASTHOST	VARCHAR(64)	NOT NULL,
   LASTADDR	VARCHAR(16)	NOT NULL,
   PRIMARY KEY(CUSTOMERID)
)\p\g

# DEFAULTS:
# ATTRIBUTE	VALUE		MEANING
# ---------	-----		--------------------------
# LANG		1		English.
# SORT		1		Date.
# RSORT		1		Yes reverse sort.
# PSIZE		20		Show 20 messages per page.
# SAVESENT	0		No.
# MOVETRASH	0		No, permanently delete.
# THEME		0		Default theme

CREATE TABLE SETTINGS (
   ROWID	BIGINT(21)	NOT NULL DEFAULT '1' AUTO_INCREMENT,
   CUSTOMERID	BIGINT(21)	NOT NULL,
   NAME		VARCHAR(64),
   SIGN		VARCHAR(80),
   LANG		INT		NOT NULL DEFAULT '1',
   SORT		INT		NOT NULL DEFAULT '1',
   RSORT	INT		NOT NULL DEFAULT '1',
   PSIZE	INT		NOT NULL DEFAULT '20',
   SAVESENT	INT		NOT NULL DEFAULT '0',
   MOVETRASH	INT		NOT NULL DEFAULT '0',
   THEME	INT		NOT NULL DEFAULT '0',
   PRIMARY KEY(ROWID)
)\p\g
  
